#include "pimage.h"
#include <stdlib.h>
#include <qdebug.h>
#include <qevent.h>

PImage::PImage(QWidget *parent) : QLabel(parent)
{
        doDraw = false;
        this->setWhatsThis(QString(tr("the light spot image used in projections and width calculations")));
        this->setToolTip(QString(tr("the current light spot image")));
}
/*!
    \fn PPImage::mouseMoveEvent(QMouseEvent *)
 */
void PImage::mouseMoveEvent(QMouseEvent *evt)
{
    if (doDraw)
    {
        QPoint pos = evt -> pos();
        x2 = evt -> x();
        y2 = evt -> y();
        update();
    }
}

/*!
    \fn PImage::mousePressEvent(QMouseEvent *)
 */
void PImage::mousePressEvent(QMouseEvent *evt)
{
    if (evt -> button() == Qt::LeftButton)
    {
        doDraw = true;
        x1 = evt -> x();
        y1 = evt -> y();
        x2 = x1;
        y2 = y1;
        update();
    }
}


/*!
    \fn PImage::mouseReleaseEvent(QMouseEvent *)
 */
void PImage::mouseReleaseEvent(QMouseEvent *evt)
{
    if (evt -> button() == Qt::LeftButton)
    {
        doDraw = false;
        update();
    }
    if (evt -> button() == Qt::RightButton) {
        qDebug() << "Right Button Pressed" << endl;
        emit resetPixmap();
    }
}

/*!
    \fn PImage::setPixmap(QPixmap pixmap)
 */

void PImage::setPixmap(QPixmap pixmap)
{
        m_pixmap = pixmap;
        update();
}
/*!
    \fn PImage::paintEvent(QPaintEvent *)
 */

void PImage::paintEvent(QPaintEvent *)
{

        QPainter paint(this);

        paint.eraseRect(0,10,width(),height());
        paint.drawPixmap(0,10,m_pixmap);
        paint.setPen(QColor(Qt::green));
        if ((x1 != x2) && (y1 != y2))
        paint.drawRect( x1, y1 ,x2-x1,y2-y1);
 //               paint.drawLine( x, 0 ,x, height);

}

QRect PImage::getAoi()
{
    QRect aoi(x1,y1,x2,y2);
    return aoi;
}

